static const char file_id[] = "../../../../../src/contrib/atrade/de/stars/DESink.pl";
// .cc file generated from ../../../../../src/contrib/atrade/de/stars/DESink.pl by ptlang
/*
Copyright (c) 1995 Sanders, a Lockheed Martin Company
All rights reserved.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DESink.h"
#include "DEProcessor.h"

const char *star_nm_DESink = "DESink";

const char* DESink :: className() const {return star_nm_DESink;}

ISA_FUNC(DESink,DEStar);

Block* DESink :: makeNew() const { LOG_NEW; return new DESink;}

DESink::DESink ()
{
	setDescriptor("Captures DE DataBlock particles and prints them out.");
	addPort(inputPort.setPort("inputPort",this,MESSAGE));
	addState(processorNumber.setState("processorNumber",this,"0","Unique id of the sink so it can be addressed",
# line 30 "../../../../../src/contrib/atrade/de/stars/DESink.pl"
A_CONSTANT | A_SETTABLE));

# line 35 "../../../../../src/contrib/atrade/de/stars/DESink.pl"
delayType = FALSE;
}

void DESink::go() {
# line 41 "../../../../../src/contrib/atrade/de/stars/DESink.pl"
Envelope pkt;
	  (inputPort.get()).getMessage(pkt);
	  if (!pkt.typeCheck("DataBlock"))
	    {
	    cerr << "Fatal Error: " << this->fullName() << ", typeError(DataBlock)" << endl;
	    Error::abortRun(*this, pkt.typeError("DataBlock"));
	    return;
	    }
	  const DataBlock *dataBlockPtr = (const DataBlock *)pkt.myData();
     	  clog.open(DEProcessor::logname, ios::app);
	  if (dataBlockPtr->processor() != processorNumber)
	    {
	    clog << this->fullName() << ", a data block of " << dataBlockPtr->dataSize() << " samples of ";
	    clog << dataBlockPtr->dataRepresentation() << " arrived at time " << arrivalTime;
	    clog << " and did not match this sink and has been ignored" << endl;
	    }
	  else
            {
	    clog << this->fullName() << ", a data block of " << dataBlockPtr->dataSize() << " samples of ";
	    clog << dataBlockPtr->dataRepresentation() << " arrived at time " << arrivalTime << endl;
	    }
	  clog.close();
}

// prototype instance for known block list
static DESink proto;
static RegisterBlock registerBlock(proto,"Sink");
