defstar {
	name {Sink}
	domain {DE}
	version { $Revision: 1.4 $ $Date: 1995/07/17 23:47:03 $ }
	author { E. K. Pauer }
	copyright {
Copyright (c) 1995 Sanders, a Lockheed Martin Company
All rights reserved.
	}
	acknowledge {
This work was performed by Sanders, a Lockheed Martin Company, as part
of the Sanders RASSP program under contract N00014-93-C-2172 to the
Naval Research Laboratory, 4555 Overlook Avenue, SW, Washington, DC
20375-5326. The Sponsoring Agency is: Advanced Research Projects
Agency, Electronic System Technology Office, 3701 North Fairfax
Drive, Arlington, VA 22203-1714. The Sanders RASSP team consists of
Sanders, Motorola, Hughes, and ISX.
}
	location { $PTOLEMY/src/contrib/atrade/de/stars }
	desc { Captures DE DataBlock particles and prints them out. }
	input {
		name {inputPort}
		type {message}
	}
	defstate {
		name {processorNumber}
		type {int}
		default {0}
		desc { Unique id of the sink so it can be addressed }
		attributes { A_CONSTANT | A_SETTABLE }
	}
	hinclude { <iostream.h>, <fstream.h>, "Message.h", "DataBlock.h" }
        ccinclude { "DEProcessor.h" }
	constructor {
		delayType = FALSE;
	}
        protected {
    		ofstream clog;
        }
	go {
	  Envelope pkt;
	  (inputPort.get()).getMessage(pkt);
	  if (!pkt.typeCheck("DataBlock"))
	    {
	    cerr << "Fatal Error: " << this->fullName() << ", typeError(DataBlock)" << endl;
	    Error::abortRun(*this, pkt.typeError("DataBlock"));
	    return;
	    }
	  const DataBlock *dataBlockPtr = (const DataBlock *)pkt.myData();
     	  clog.open(DEProcessor::logname, ios::app);
	  if (dataBlockPtr->processor() != processorNumber)
	    {
	    clog << this->fullName() << ", a data block of " << dataBlockPtr->dataSize() << " samples of ";
	    clog << dataBlockPtr->dataRepresentation() << " arrived at time " << arrivalTime;
	    clog << " and did not match this sink and has been ignored" << endl;
	    }
	  else
            {
	    clog << this->fullName() << ", a data block of " << dataBlockPtr->dataSize() << " samples of ";
	    clog << dataBlockPtr->dataRepresentation() << " arrived at time " << arrivalTime << endl;
	    }
	  clog.close();
	}
}

