static const char file_id[] = "../../../../../src/contrib/atrade/de/stars/DESource.pl";
// .cc file generated from ../../../../../src/contrib/atrade/de/stars/DESource.pl by ptlang
/*
Copyright (c) 1995 Sanders, a Lockheed Martin Company
All rights reserved.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DESource.h"
#include "DEProcessor.h"

const char *star_nm_DESource = "DESource";

const char* DESource :: className() const {return star_nm_DESource;}

ISA_FUNC(DESource,DERepeatStar);

Block* DESource :: makeNew() const { LOG_NEW; return new DESource;}

DESource::DESource ()
{
	setDescriptor("Creates DataBlock particles at a periodic rate.");
	addPort(outputPort.setPort("outputPort",this,MESSAGE));
	addState(processorMapping.setState("processorMapping",this,"0","Processor to which DataBlocks will be routed",
# line 31 "../../../../../src/contrib/atrade/de/stars/DESource.pl"
A_CONSTANT | A_SETTABLE));
	addState(functionBlockMapping.setState("functionBlockMapping",this,"0","FunctionBlock to which DataBlocks will be routed",
# line 38 "../../../../../src/contrib/atrade/de/stars/DESource.pl"
A_CONSTANT | A_SETTABLE));
	addState(inputPortMapping.setState("inputPortMapping",this,"0","Port on FunctionBlock to which DataBlocks will be routed",
# line 45 "../../../../../src/contrib/atrade/de/stars/DESource.pl"
A_CONSTANT | A_SETTABLE));
	addState(dataType.setState("dataType",this,"FLOAT","Type of data which DataBlock will carry",
# line 52 "../../../../../src/contrib/atrade/de/stars/DESource.pl"
A_CONSTANT | A_SETTABLE));
	addState(blockSize.setState("blockSize",this,"1","Size of DataBlocks that are generated",
# line 59 "../../../../../src/contrib/atrade/de/stars/DESource.pl"
A_CONSTANT | A_SETTABLE));
	addState(frequency.setState("frequency",this,"0.0","Frequency at which DataBlocks will be generated",
# line 66 "../../../../../src/contrib/atrade/de/stars/DESource.pl"
A_CONSTANT | A_SETTABLE));
	addState(delay.setState("delay",this,"0.0","Initial delay before generating DataBlocks",
# line 73 "../../../../../src/contrib/atrade/de/stars/DESource.pl"
A_CONSTANT | A_SETTABLE));


}

void DESource::setup() {
# line 84 "../../../../../src/contrib/atrade/de/stars/DESource.pl"
if ( !strcmp(dataType, INT) && !strcmp(dataType, FLOAT) &&
               !strcmp(dataType, COMPLEX) && !strcmp(dataType, FIX))
	    {
	    cerr << "Fatal Error: " << this->fullName() << ", Illegal type for data representation" << endl;
	    Error::abortRun(*this, "Illegal type for data representation");
	    }
	  if (frequency > 0.0)
	    interval = 1.0 / double(frequency);
	  else
            interval = 0.0;
}

void DESource::go() {
# line 96 "../../../../../src/contrib/atrade/de/stars/DESource.pl"
// add initial delay on first firing
	  if (completionTime == 0.0)
	    completionTime += delay;

	  // create DataBlock particle
	  pd = new DataBlock(blockSize, dataType, processorMapping, functionBlockMapping, inputPortMapping);
	  Envelope pkt(*pd);
	  outputPort.put(completionTime) << pkt;

     	  clog.open(DEProcessor::logname, ios::app);
	  clog << this->fullName() << ", a data block of " << blockSize << " samples of ";
	  clog << dataType  << " created and sent to functionBlock " << functionBlockMapping;
	  clog << " (inputPort " << inputPortMapping << ") on processor " << processorMapping;
	  clog << " at time " << completionTime << endl;
	  clog.close();

	  // fire only once if frequency is zero
	  if (interval == 0.0)
	    return;

	  // schedule the next firing
	  refireAtTime(completionTime);
	  // increment completion time
	  completionTime += double(interval);
}

// prototype instance for known block list
static DESource proto;
static RegisterBlock registerBlock(proto,"Source");
