static const char file_id[] = "../../../../../src/contrib/atrade/sdf/stars/SDFOrthogonalize.pl";
// .cc file generated from ../../../../../src/contrib/atrade/sdf/stars/SDFOrthogonalize.pl by ptlang
/*
Copyright (c) 1995 Sanders, a Lockheed Martin Company
All rights reserved.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFOrthogonalize.h"
#include <math.h>

const char *star_nm_SDFOrthogonalize = "SDFOrthogonalize";

const char* SDFOrthogonalize :: className() const {return star_nm_SDFOrthogonalize;}

ISA_FUNC(SDFOrthogonalize,SDFStar);

Block* SDFOrthogonalize :: makeNew() const { LOG_NEW; return new SDFOrthogonalize;}

SDFOrthogonalize::SDFOrthogonalize ()
{
	setDescriptor("Orthogonalizes the complex input vector with the given complex basis vector");
	addState(blockSize.setState("blockSize",this,"256","Size of vector"));
	addPort(vin.setPort("vin",this,COMPLEX));
	addPort(qin.setPort("qin",this,COMPLEX));
	addPort(vout.setPort("vout",this,COMPLEX));
	addPort(qout.setPort("qout",this,COMPLEX));


}

void SDFOrthogonalize::setup() {
# line 44 "../../../../../src/contrib/atrade/sdf/stars/SDFOrthogonalize.pl"
vin.setSDFParams(int(blockSize), int(blockSize)-1);
	  qin.setSDFParams(int(blockSize), int(blockSize)-1);
	  vout.setSDFParams(int(blockSize), int(blockSize)-1);
	  qout.setSDFParams(int(blockSize), int(blockSize)-1);
}

void SDFOrthogonalize::go() {
# line 52 "../../../../../src/contrib/atrade/sdf/stars/SDFOrthogonalize.pl"
Complex r(0.0, 0.0);
		int i;
		for (i = int(blockSize)-1; i >= 0; i--)
		  r = r + (Complex(vin%i) * conj(Complex(qin%i)));
		for (i = int(blockSize)-1; i >= 0; i--) {
	          vout%i << (Complex(vin%i) - Complex(Complex(r) * Complex(qin%i)));
		  qout%i << Complex(qin%i);
	        }
}

// prototype instance for known block list
static SDFOrthogonalize proto;
static RegisterBlock registerBlock(proto,"Orthogonalize");
